unit Unit1;

//Lazzy Image Viewer
//github.com/PascalVault
//License: GNU/GPL

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls,
  StdCtrls, Buttons, Menus, LCLIntf, LCLType, ShellApi, Clipbrd, Math,
  PV_Bitmap, PV_BitmapFormats, PV_Filters, Printers, PrintersDlgs, Types,
  dlg_colors, dlg_resize, dlg_params, dlg_about, IntfGraphics, FPImage, FPReadJPEG;

const Levels: array of Extended = (0.1, 0.15, 0.20, 0.25, 0.3, 0.5, 0.7, 1, 1.5, 2, 3, 4, 5, 6, 7, 8);

type

  { TTabSheet }

  TTabSheet = class(ComCtrls.TTabSheet)
  public
    Bmp: TPV_Bitmap;
    Zoom: Extended;
    Filename: String;
    UndoPos: Integer;
    UndoList: array[0..9] of TPV_Bitmap;
    ScrollbarV: TScrollbar;
    ScrollbarH: TScrollbar;
    List: TStringList;
    ListPos: Integer;
    procedure Close;
    procedure ListFiles(AFilename: String);
  end;

  { TForm1 }

  TForm1 = class(TForm)
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem22: TMenuItem;
    MenuItem23: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    MenuItem26: TMenuItem;
    MenuItem27: TMenuItem;
    MenuItem28: TMenuItem;
    MenuItem29: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem30: TMenuItem;
    MenuItem31: TMenuItem;
    MenuItem32: TMenuItem;
    MenuItem33: TMenuItem;
    MenuItem34: TMenuItem;
    MenuItem35: TMenuItem;
    MenuItem36: TMenuItem;
    MenuItem37: TMenuItem;
    MenuItem38: TMenuItem;
    MenuItem39: TMenuItem;
    MenuItem40: TMenuItem;
    MenuItem41: TMenuItem;
    MenuItem42: TMenuItem;
    MenuItem43: TMenuItem;
    MenuItem44: TMenuItem;
    MenuItem45: TMenuItem;
    MenuItem46: TMenuItem;
    MenuItem47: TMenuItem;
    Separator4: TMenuItem;
    Separator3: TMenuItem;
    Separator2: TMenuItem;
    PopupMenu5: TPopupMenu;
    PopupMenu6: TPopupMenu;
    Separator1: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    OpenDialog1: TOpenDialog;
    PG: TPageControl;
    Panel1: TPanel;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    PopupMenu3: TPopupMenu;
    PopupMenu4: TPopupMenu;
    PrintDialog1: TPrintDialog;
    SaveDialog1: TSaveDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of string);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure MenuItem10Click(Sender: TObject);
    procedure MenuItem11Click(Sender: TObject);
    procedure MenuItem12Click(Sender: TObject);
    procedure MenuItem13Click(Sender: TObject);
    procedure MenuItem14Click(Sender: TObject);
    procedure MenuItem15Click(Sender: TObject);
    procedure MenuItem16Click(Sender: TObject);
    procedure MenuItem17Click(Sender: TObject);
    procedure MenuItem18Click(Sender: TObject);
    procedure MenuItem19Click(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem20Click(Sender: TObject);
    procedure MenuItem21Click(Sender: TObject);
    procedure MenuItem22Click(Sender: TObject);
    procedure MenuItem23Click(Sender: TObject);
    procedure MenuItem24Click(Sender: TObject);
    procedure MenuItem26Click(Sender: TObject);
    procedure MenuItem28Click(Sender: TObject);
    procedure MenuItem29Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem30Click(Sender: TObject);
    procedure MenuItem32Click(Sender: TObject);
    procedure MenuItem33Click(Sender: TObject);
    procedure MenuItem34Click(Sender: TObject);
    procedure MenuItem35Click(Sender: TObject);
    procedure MenuItem37Click(Sender: TObject);
    procedure MenuItem38Click(Sender: TObject);
    procedure MenuItem39Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem40Click(Sender: TObject);
    procedure MenuItem41Click(Sender: TObject);
    procedure MenuItem42Click(Sender: TObject);
    procedure MenuItem43Click(Sender: TObject);
    procedure MenuItem44Click(Sender: TObject);
    procedure MenuItem45Click(Sender: TObject);
    procedure MenuItem46Click(Sender: TObject);
    procedure MenuItem47Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure PGMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ScrollBar1Change(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure SpeedButton16Click(Sender: TObject);
    procedure SpeedButton17Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
  private
    procedure OnPanelPaint(Sender: TObject);
  public
    IsFullscreen: Boolean;
    WinSize: TRect;
    procedure OpenImage(Filename: String);
    function ReOpenImage(Filename: String; ASheet: TTabSheet): Boolean;
    procedure DrawBmp(Image: TImage; Bmp: TPV_Bitmap);
    function GetBmp: TPV_Bitmap;
    function GetSheet: TTabSheet;
    function NoImage: Boolean;
    procedure Redraw;
    function ZoomIn(Val: Extended): Extended;
    function ZoomOut(Val: Extended): Extended;
    procedure SaveUndo;
    procedure Undo;
    procedure FixScrollbars;
    procedure EnterFullscreen;
    procedure LeaveFullscreen;
    procedure ShowInfo;
    procedure ShowZoom;
    procedure ErrorBox(Msg: String);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TTabSheet }

procedure TTabSheet.Close;
begin
  Bmp.Free;
  List.Free;
  Self.Free;
end;

procedure TTabSheet.ListFiles(AFilename: String);
 var sr: TSearchRec;
     Dir: String;
     FilenameLow: String;
     k: Integer;
 begin
  Dir := ExtractFilePath(AFilename);
  List.Clear;
  FilenameLow := LowerCase(AFilename);
  ListPos := -1;

  if FindFirst(Dir + '*', faAnyFile - faDirectory, sr) <> 0 then Exit;

  k := 0;
  repeat
    List.Add(Dir + sr.Name);

    if LowerCase(Dir + sr.Name) = FilenameLow then ListPos := List.Count-1;

    Inc(k);

    if k mod 100 = 0 then Application.ProcessMessages;
  until FindNext(sr) <> 0;

  FindClose(sr);
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
begin
  IsFullScreen := False;

  for i:=1 to ParamCount do
    OpenImage(ParamStr(i));
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i: Integer;
begin
  for i:=PG.PageCount-1 downto 0 do
    TTabSheet(PG.Pages[i]).Close;
end;

procedure TForm1.FormDropFiles(Sender: TObject; const FileNames: array of string);
var i: Integer;
begin
  for i:=0 to High(Filenames) do OpenImage(Filenames[i]);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
  if Key = VK_ESCAPE then LeaveFullscreen;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  SpeedButton13.Click;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  SpeedButton12.Click;
end;

procedure TForm1.MenuItem10Click(Sender: TObject);
begin
  SaveUndo;
  GetBmp.Emboss;
  Redraw;
end;

procedure TForm1.MenuItem11Click(Sender: TObject);
begin
  with ParamsDlg do begin
    TheMin := 0;
    TheMax := 100;
    TheVal := 10;
    Setup;
    ShowModal;
  end;

  SaveUndo;
  GetBmp.Contrast(ParamsDlg.TheVal);
  Redraw;
end;

procedure TForm1.MenuItem12Click(Sender: TObject);
begin
  with ParamsDlg do begin
    TheMin := -100;
    TheMax := 100;
    TheVal := 0;
    Setup;
    ShowModal;
  end;

  SaveUndo;
  GetBmp.Brightness(ParamsDlg.TheVal);
  Redraw;
end;

procedure TForm1.MenuItem13Click(Sender: TObject);
begin
  SaveUndo;
  GetBmp.Grayscale(256, ddNone);
  Redraw;
end;

procedure TForm1.MenuItem14Click(Sender: TObject);
begin
  SaveUndo;
  GetBmp.Negate;
  Redraw;
end;

procedure TForm1.MenuItem15Click(Sender: TObject);
begin
  if NoImage then Exit;

  SaveUndo;
  GetBmp.Rotate90;
  Redraw;
end;

procedure TForm1.MenuItem16Click(Sender: TObject);
begin
  if NoImage then Exit;

  SaveUndo;
  GetBmp.Rotate270;
  Redraw;
end;

procedure TForm1.MenuItem17Click(Sender: TObject);
begin
  if NoImage then Exit;

  SaveUndo;
  GetBmp.Rotate180;
  Redraw;
end;

procedure TForm1.MenuItem18Click(Sender: TObject);
begin
  if NoImage then Exit;

  SaveUndo;
  GetBmp.FlipH;
  Redraw;
end;

procedure TForm1.MenuItem19Click(Sender: TObject);
begin
  if NoImage then Exit;

  SaveUndo;
  GetBmp.FlipV;
  Redraw;
end;

procedure TForm1.MenuItem1Click(Sender: TObject);
begin
  SaveUndo;
  GetBmp.BoxBlur;
  Redraw;
end;

procedure TForm1.MenuItem20Click(Sender: TObject);
begin
  ColorsDlg.Show(256);
end;

procedure TForm1.MenuItem21Click(Sender: TObject);
begin
  ColorsDlg.Show(-256);
end;

procedure TForm1.MenuItem22Click(Sender: TObject);
begin
  GetBmp.Highcolor(15);
end;

procedure TForm1.MenuItem23Click(Sender: TObject);
begin
  ColorsDlg.Show(2);
end;

procedure TForm1.MenuItem24Click(Sender: TObject);
begin
  GetBmp.Highcolor(16);
end;

procedure TForm1.MenuItem26Click(Sender: TObject);
begin
  Undo;
end;

procedure TForm1.MenuItem28Click(Sender: TObject);
begin
  SpeedButton1.Click;
end;

procedure TForm1.MenuItem29Click(Sender: TObject);
var Sheet: TTabSheet;
begin
  Sheet := GetSheet;
  if Sheet = nil then Exit;
  Sheet.Close;
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
begin
  SaveUndo;
  GetBmp.GaussBlur;
  Redraw;
end;

procedure TForm1.MenuItem30Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.MenuItem32Click(Sender: TObject);
begin
  AboutDlg.Show;
end;

procedure TForm1.MenuItem33Click(Sender: TObject);
begin
  SpeedButton6.Click;
end;

procedure TForm1.MenuItem34Click(Sender: TObject);
begin
  SpeedButton16.Click;
end;

procedure TForm1.MenuItem35Click(Sender: TObject);
begin
  SpeedButton2.Click;
end;

procedure TForm1.MenuItem37Click(Sender: TObject);
begin
  EnterFullscreen;
end;

procedure TForm1.MenuItem38Click(Sender: TObject);
var Sheet: TTabSheet;
    Pos: Integer;
    i: Integer;
begin
 if NoImage then Exit;
 Sheet := GetSheet;

  for i:=1 to 200 do begin // try 200 times
    Pos := Sheet.ListPos + i;
    if Pos > Sheet.List.Count-1 then Exit;

    if ReOpenImage(Sheet.List[Pos], Sheet) then break;

    Sheet.ListPos := Pos;
  end;

  Redraw;
end;

procedure TForm1.MenuItem39Click(Sender: TObject);
var Sheet: TTabSheet;
    Pos: Integer;
    i: Integer;
begin
 if NoImage then Exit;
 Sheet := GetSheet;

  for i:=1 to 200 do begin // try 200 times
    Pos := Sheet.ListPos - i;
    if Pos < 0 then Exit;

    if ReOpenImage(Sheet.List[Pos], Sheet) then break;

    Sheet.ListPos := Pos;
  end;

  Redraw;
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  SaveUndo;
  GetBmp.GaussBlur5;
  Redraw;
end;

procedure TForm1.MenuItem40Click(Sender: TObject);
var Cur: Integer;
begin
  Cur := PopupMenu5.Tag;
  TTabSheet(PG.Pages[Cur]).Close;
end;

procedure TForm1.MenuItem41Click(Sender: TObject);
var i: Integer;
    Cur: Integer;
begin
 Cur := PopupMenu5.Tag;

  for i:=PG.PageCount-1 downto 0 do begin
    if i <> Cur then TTabSheet(PG.Pages[i]).Close;
  end;
end;

procedure TForm1.MenuItem42Click(Sender: TObject);
var i: Integer;
    Cur: Integer;
begin
  Cur := PopupMenu5.Tag;

  for i:=PG.PageCount-1 downto 0 do begin
    TTabSheet(PG.Pages[i]).Close;
  end;
end;

procedure TForm1.MenuItem43Click(Sender: TObject);
begin
  MenuItem38.Click;
end;

procedure TForm1.MenuItem44Click(Sender: TObject);
begin
  MenuItem39.Click;
end;

procedure TForm1.MenuItem45Click(Sender: TObject);
begin
 SpeedButton6.Click;
end;

procedure TForm1.MenuItem46Click(Sender: TObject);
begin
  SpeedButton9.Click;
end;

procedure TForm1.MenuItem47Click(Sender: TObject);
begin
 SaveUndo;
 GetBmp.Trim(0,0,0);
 FixScrollbars;
 Redraw;
end;

procedure TForm1.MenuItem4Click(Sender: TObject);
begin
  SaveUndo;
  GetBmp.SmarterBlur;
  Redraw;
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  SaveUndo;
  GetBmp.Unsharp;
  Redraw;
end;

procedure TForm1.MenuItem6Click(Sender: TObject);
begin
  SaveUndo;
  GetBmp.Sharpen;
  Redraw;
end;

procedure TForm1.MenuItem7Click(Sender: TObject);
begin
  with ParamsDlg do begin
    TheMin := 0;
    TheMax := 100;
    TheVal := 20;
    Setup;
    ShowModal;
  end;

  SaveUndo;
  GetBmp.Sepia(ParamsDlg.TheVal);
  Redraw;
end;

procedure TForm1.MenuItem8Click(Sender: TObject);
begin
  with ParamsDlg do begin
    TheMin := 0;
    TheMax := 100;
    TheVal := 20;
    Setup;
    ShowModal;
  end;

  SaveUndo;
  GetBmp.AddNoise(ParamsDlg.TheVal);
  Redraw;
end;

procedure TForm1.MenuItem9Click(Sender: TObject);
begin
  SaveUndo;
  GetBmp.FindEdges;
  Redraw;
end;

procedure TForm1.PGMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Tabindex: Integer;
    P: TPoint;
begin
  if button = mbright then begin
    Tabindex := TPageControl(Sender).IndexOfTabAt(X, Y);
    if Tabindex >= 0 then begin
      P.X := X;
      P.Y := Y;
      P := TPageControl(Sender).ClientToScreen(P);

      PopupMenu5.Tag := TabIndex;
      PopupMenu5.PopUp(P.X, P.Y);
    end;
  end;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  Redraw;
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
var P: TPoint;
    Button: TSpeedButton;
begin
  if NoImage then Exit;
  Button := Sender as TSpeedButton;

  P := Point(Button.Left, Button.Height);
  P := Form1.ClientToScreen(P);

  PopupMenu4.Popup(P.X, P.Y);
end;

procedure TForm1.SpeedButton11Click(Sender: TObject);
var P: TPoint;
    Button: TSpeedButton;
begin
  if NoImage then Exit;
  Button := Sender as TSpeedButton;

  P := Point(Button.Left, Button.Height);
  P := Form1.ClientToScreen(P);

  PopupMenu3.Popup(P.X, P.Y);
end;

procedure TForm1.SpeedButton12Click(Sender: TObject);
var Sheet: TTabSheet;
begin
  if NoImage then Exit;

  Sheet := PG.ActivePage as TTabSheet;

  Sheet.Zoom := ZoomIn(Sheet.Zoom);
  FixScrollbars;
  ShowZoom;
  Redraw;
end;

procedure TForm1.SpeedButton13Click(Sender: TObject);
var Sheet: TTabSheet;
begin
  if NoImage then Exit;

  Sheet := PG.ActivePage as TTabSheet;

  Sheet.Zoom := ZoomOut(Sheet.Zoom);
  FixScrollbars;
  ShowZoom;
  Redraw;
end;

procedure TForm1.SpeedButton14Click(Sender: TObject);
var Sheet: TTabSheet;
begin
  if NoImage then Exit;

  Sheet := PG.ActivePage as TTabSheet;

  Sheet.Zoom := 1;
  FixScrollbars;
  ShowZoom;
  Redraw;
end;

procedure TForm1.SpeedButton15Click(Sender: TObject);
var fileOpStruct: TSHFileOpStruct;
    Sheet: TTabSheet;
begin
  if NoImage then Exit;

  fileOpStruct.Wnd := 0;
  fileOpStruct.wFunc := FO_DELETE;
  fileOpStruct.pFrom := PChar(TTabSheet(PG.ActivePage).Filename + #0 + #0);
  fileOpStruct.fFlags := FOF_ALLOWUNDO + FOF_NOCONFIRMATION;
  SHFileOperation( fileOpStruct );

  Sheet := GetSheet;
  Sheet.Close;
end;

procedure TForm1.SpeedButton16Click(Sender: TObject);
var Bmp: TBitmap;
begin
  if NoImage then Exit;

  if not Clipboard.HasFormat(PredefinedClipboardFormat(pcfBitmap)) then Exit;

  Bmp := TBitmap.Create;
  Bmp.LoadFromClipboardFormat(PredefinedClipboardFormat(pcfBitmap));

  GetBmp.CopyFrom(Bmp);

  Redraw;

  Bmp.Free;
end;

procedure TForm1.SpeedButton17Click(Sender: TObject);
var P: TPoint;
    Button: TSpeedButton;
begin
  if NoImage then Exit;
  Button := Sender as TSpeedButton;

  P := Point(Button.Left, Button.Height);
  P := Form1.ClientToScreen(P);

  PopupMenu1.Popup(P.X, P.Y);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var i: Integer;
begin
  if not OpenDialog1.Execute then Exit;

  for i:=0 to OpenDialog1.Files.Count-1 do
    OpenImage(OpenDialog1.Files[i]);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if NoImage then Exit;

  if not SaveDialog1.Execute then Exit;

  GetBmp.SaveToFile(SaveDialog1.Filename);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var P: TPoint;
    Button: TSpeedButton;
begin
  if NoImage then Exit;
  Button := Sender as TSpeedButton;

  P := Point(Button.Left, Button.Height);
  P := Form1.ClientToScreen(P);

  PopupMenu2.Popup(P.X, P.Y);
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
var Dest: TRect;
    Wid, Hei: Integer;
    Bmp: TBitmap;
begin
  if NoImage then Exit;

  if not PrintDialog1.Execute then Exit;

  Bmp := GetBmp.ToBitmap;

  Wid := Printer.PageWidth;
  Hei := Round(Wid / (Bmp.Width/Bmp.Height));

  Dest := Rect(0,0, Wid, Hei);

  Printer.BeginDoc;

  Printer.Canvas.StretchDraw(Dest, Bmp);

  Printer.EndDoc;

  Bmp.Free;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
var Bmp: TBitmap;
begin
  if NoImage then Exit;

  Bmp := GetBmp.ToBitmap;
  Clipboard.Assign(Bmp);
  Bmp.Free;
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
var ScreenDC: HDC;
    Bitmap: TBitmap;
begin
  OpenImage('');

  Hide;
  Sleep(300);
  Application.ProcessMessages;
  Bitmap := TBitmap.Create;
  ScreenDC := GetDC(0);
  try
    Bitmap.LoadFromDevice(ScreenDC);

    GetBmp.SetSize(Bitmap.Width, Bitmap.Height);
    GetBmp.CopyFrom(Bitmap);
    Redraw;

  finally
    Bitmap.Free;
    ReleaseDC(0, ScreenDC);
    Show;
  end;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
  if NoImage then Exit;

  ResizeDlg.UpDown3.Position := GetBmp.Width;
  ResizeDlg.UpDown4.Position := GetBmp.Height;
  ResizeDlg.Show;
end;

procedure TForm1.SpeedButton9Click(Sender: TObject);
begin
  if IsFullScreen then LeaveFullscreen
  else EnterFullscreen;
end;

procedure TForm1.EnterFullscreen;
var i: Integer;
begin
  for i:=0 to PG.PageCount-1 do
    PG.Pages[i].TabVisible := False;

  WinSize := Rect(Left, Top, Left+Width, Top+Height);

  Form1.BorderStyle := bsNone;
  Panel1.Visible := False;
  StatusBar1.Visible := False;
  Form1.Menu := nil;

  PG.TabIndex := 0;
  IsFullScreen := True;

  Form1.BoundsRect := Rect(0,0, Screen.Width, Screen.Height);
end;

procedure TForm1.LeaveFullscreen;
var i: Integer;
begin
  for i:=0 to PG.PageCount-1 do
    PG.Pages[i].TabVisible := True;

  Form1.BorderStyle := bsSingle;
  Panel1.Visible := True;
  StatusBar1.Visible := True;
  Form1.WindowState := wsNormal;
  Form1.Menu := MainMenu1;

  PG.TabIndex := 0;
  IsFullScreen := False;

  Form1.BoundsRect := WinSize;
end;

procedure TForm1.ShowInfo;
begin
  StatusBar1.Panels[0].Text := Format('%d x %d', [GetBmp.Width, GetBmp.Height]);
end;

procedure TForm1.ShowZoom;
begin
  StatusBar1.Panels[1].Text := IntToStr(Round(GetSheet.Zoom * 100)) + ' %';
end;

procedure TForm1.ErrorBox(Msg: String);
begin
  MessageDlg('Error', Msg, mtError, [mbOK], 0);
end;

procedure TForm1.OpenImage(Filename: String);
var Sheet: TTabSheet;
    Panel: TPanel;
    Image: TImage;
    Res: Boolean;
begin
  Sheet := TTabSheet.Create(PG);
  Sheet.Parent := PG;

  Sheet.Bmp := TPV_Bitmap.Create;

  if Filename = '' then begin
    Sheet.Caption := 'Untitled';
    Res := True;
  end
  else
    Res := Sheet.Bmp.LoadFromFile(Filename);

  if not Res then begin
    ErrorBox('Could not read file "' + ExtractFilename(Filename) + '"');
    Sheet.Close;
    Exit;
  end;

  Sheet.Zoom := 1;
  Sheet.Caption := ExtractFileName(Filename);

  Panel := TPanel.Create(Sheet);
  Panel.Parent := Sheet;
  Panel.Align := alClient;
  Panel.Color := clBtnShadow;
  Panel.OnPaint := @OnPanelPaint;
  Panel.BevelOuter := bvNone;

  Sheet.ScrollbarV := TScrollBar.Create(Sheet);
  with Sheet.ScrollbarV do begin
    Parent := Panel;
    Kind := sbVertical;
    Align := alRight;
    Width := 20;
    OnChange := @ScrollBar1Change;
  end;

  Sheet.ScrollbarH := TScrollBar.Create(Sheet);
  with Sheet.ScrollbarH do begin
    Parent := Panel;
    Align := alBottom;
    Height := 20;
    OnChange := @ScrollBar1Change;
  end;

  Sheet.Filename := Filename;
  Sheet.UndoPos := 0;
  PG.ActivePageIndex := PG.PageCount-1;

  FixScrollbars;
  ShowInfo;

  Sheet.List := TStringList.Create;
  Sheet.ListFiles(Filename);
 end;

function TForm1.ReOpenImage(Filename: String; ASheet: TTabSheet): Boolean;
begin
  Result := ASheet.Bmp.LoadFromFile(Filename);

  if not Result then Exit;

  ASheet.Zoom := 1;
  ASheet.Caption := ExtractFileName(Filename);
  ASheet.Filename := Filename;
  ASheet.UndoPos := 0;

  FixScrollbars;
  ShowInfo;

  ASheet.ListFiles(Filename);
end;


procedure TForm1.DrawBmp(Image: TImage; Bmp: TPV_Bitmap);
var Panel: TPanel;
begin
  Panel := PG.ActivePage.Controls[0] as TPanel;
end;

function TForm1.NoImage: Boolean;
begin
  Result := (PG.ActivePage = nil);
end;

procedure TForm1.Redraw;
begin
  TPanel(PG.ActivePage.Controls[0]).Repaint;
end;

function TForm1.ZoomIn(Val: Extended): Extended;
var i: Integer;
begin
  for i:=0 to High(Levels) do
    if Levels[i] > Val then Exit(Levels[i]);

  Result := Levels[High(Levels)];
end;

function TForm1.ZoomOut(Val: Extended): Extended;
var i: Integer;
begin
  for i:=High(Levels) downto 0 do
    if Levels[i] < Val then Exit(Levels[i]);

  Result := Levels[0];
end;

procedure TForm1.SaveUndo;
var i: Integer;
begin
  if GetSheet.UndoPos = 10 then begin
    GetSheet.UndoList[0].Free;

    for i:=0 to 9 do
      GetSheet.UndoList[i] := GetSheet.UndoList[i+1];
  end;

  GetSheet.UndoList[GetSheet.UndoPos] := TPV_Bitmap.Create;
  GetSheet.UndoList[GetSheet.UndoPos].CopyFrom(GetBmp);

  Inc(GetSheet.UndoPos);
end;

procedure TForm1.Undo;
begin
  if GetSheet.UndoPos < 1 then Exit;

  GetBmp.CopyFrom( GetSheet.UndoList[GetSheet.UndoPos-1] );
  Dec(GetSheet.UndoPos);
  Redraw;
end;

procedure TForm1.FixScrollbars;
var Sheet: TTabSheet;
    Bmp: TPV_Bitmap;
    Wid, Hei: Integer;
begin
  Sheet := GetSheet;
  Bmp   := GetBmp;

  Sheet.ScrollBarV.Position := 0;
  Sheet.ScrollBarH.Position := 0;

  Wid := Bmp.Width - Round(PG.Width / Sheet.Zoom);

  Hei := Bmp.Height - Round(PG.Height / Sheet.Zoom);

  Sheet.ScrollBarH.Max := Max(0, Wid);
  Sheet.ScrollBarV.Max := Max(0, Hei);

  Sheet.ScrollBarV.Enabled := Hei > 0;
  Sheet.ScrollBarH.Enabled := Wid > 0;
end;

procedure TForm1.OnPanelPaint(Sender: TObject);
var Panel: TPanel;
    Sheet: TTabSheet;
    Bmp: TPV_Bitmap;
    Dest: TRect;
    Piece: TBitmap;
    Wid, Hei: Integer;
begin
  Panel := Sender as TPanel;
  Sheet := TTabSheet(Panel.Parent);

  if Sheet.Zoom = 0 then Exit;

  Bmp := Sheet.Bmp;

  Wid := Round(PG.Width  / Sheet.Zoom);
  Hei := Round(PG.Height / Sheet.Zoom);

  Piece := Bmp.GetPiece(Sheet.ScrollBarH.Position, Sheet.ScrollBarV.Position, Wid, Hei);

  Dest := Rect(0,0, Round(Wid*Sheet.Zoom), Round(Hei*Sheet.Zoom));

  Panel.Canvas.Brush.Color := Panel.Color;
  Panel.Canvas.FillRect(0,0, Panel.Width, Panel.Height);
  Panel.Canvas.StretchDraw(Dest, Piece);
  Piece.Free;
end;

function TForm1.GetBmp: TPV_Bitmap;
var Sheet: TTabSheet;
begin
  if NoImage then Exit(nil);

  Sheet := PG.ActivePage as TTabSheet;

  Result := Sheet.Bmp;
end;

function TForm1.GetSheet: TTabSheet;
begin
  Result := PG.ActivePage as TTabSheet;
end;

end.

